// Generated by CoffeeScript 1.10.0
(function() {
  var Combokeys, React, ReactDOM, invariant, shortcuts;

  React = require('react');

  ReactDOM = require('react-dom');

  invariant = require('invariant');

  Combokeys = require('combokeys');

  shortcuts = React.createFactory('shortcuts');

  module.exports = React.createClass({
    displayName: 'Shortcuts',
    _combokeys: null,
    _lastEventTimestamp: null,
    contextTypes: {
      shortcuts: React.PropTypes.object.isRequired
    },
    propTypes: {
      handler: React.PropTypes.func.isRequired,
      name: React.PropTypes.string.isRequired,
      tabIndex: React.PropTypes.number,
      className: React.PropTypes.string,
      eventType: React.PropTypes.string,
      stopPropagation: React.PropTypes.bool,
      preventDefault: React.PropTypes.bool,
      targetNodeSelector: React.PropTypes.string,
      global: React.PropTypes.bool
    },
    getDefaultProps: function() {
      return {
        tabIndex: null,
        className: null,
        eventType: null,
        stopPropagation: true,
        preventDefault: false,
        targetNodeSelector: null,
        global: false
      };
    },
    _bindShortcuts: function(shortcutsArr) {
      var element;
      element = this._getElementToBind();
      element.setAttribute('tabindex', this.props.tabIndex || -1);
      this._combokeys = new Combokeys(element);
      this._decorateCombokeys();
      this._combokeys.bind(shortcutsArr, this._handleShortcuts, this.props.eventType);
      if (this.props.global) {
        return element.addEventListener('shortcuts:global', this._customGlobalHandler);
      }
    },
    _customGlobalHandler: function(e) {
      var character, event, modifiers, ref, targetNode;
      ref = e.detail, character = ref.character, modifiers = ref.modifiers, event = ref.event;
      targetNode = null;
      if (this.props.targetNodeSelector) {
        targetNode = document.querySelector(this.props.targetNodeSelector);
      }
      if (event.timeStamp === this._lastTimestamp) {
        return;
      }
      this._lastTimestamp = event.timeStamp;
      if (e.target !== ReactDOM.findDOMNode(this) && e.target !== targetNode) {
        return this._combokeys.handleKey(character, modifiers, event, true);
      }
    },
    _decorateCombokeys: function() {
      var element, originalHandleKey;
      element = this._getElementToBind();
      originalHandleKey = this._combokeys.handleKey.bind(this._combokeys);
      this._combokeys.stopCallback = function(event, element, combo) {
        var isInputLikeElement, isReturnString, ref;
        isInputLikeElement = element.tagName === 'INPUT' || element.tagName === 'SELECT' || element.tagName === 'TEXTAREA' || (element.contentEditable && element.contentEditable === 'true');
        isReturnString = ((ref = event.key) != null ? ref.length : void 0) === 1;
        if (isInputLikeElement && isReturnString) {
          return true;
        }
        return false;
      };
      return this._combokeys.handleKey = (function(_this) {
        return function(character, modifiers, event, customEvent) {
          if (!customEvent) {
            element.dispatchEvent(new CustomEvent('shortcuts:global', {
              detail: {
                character: character,
                modifiers: modifiers,
                event: event
              },
              bubbles: true,
              cancelable: true
            }));
          }
          if (_this.props.preventDefault) {
            event.preventDefault();
          }
          if (_this.props.stopPropagation && !customEvent) {
            event.stopPropagation();
          }
          return originalHandleKey(character, modifiers, event);
        };
      })(this);
    },
    _getElementToBind: function() {
      var element;
      if (this.props.targetNodeSelector) {
        element = document.querySelector(this.props.targetNodeSelector);
        invariant(element, "Node selector '" + this.props.targetNodeSelector + "'  was not found.");
      } else {
        element = ReactDOM.findDOMNode(this);
      }
      return element;
    },
    _unbindShortcuts: function() {
      var element;
      element = this._getElementToBind();
      element.removeAttribute('tabindex');
      if (this._combokeys) {
        this._combokeys.detach();
        return this._combokeys.reset();
      }
    },
    _onUpdate: function() {
      var shortcutsArr;
      shortcutsArr = this.context.shortcuts.getShortcuts(this.props.name);
      this._unbindShortcuts();
      return this._bindShortcuts(shortcutsArr);
    },
    componentDidMount: function() {
      this._onUpdate();
      return this.context.shortcuts.addUpdateListener(this._onUpdate);
    },
    componentWillUnmount: function() {
      var element, shortcutsArr;
      shortcutsArr = this.context.shortcuts.getShortcuts(this.props.name);
      this._unbindShortcuts(shortcutsArr);
      this.context.shortcuts.removeUpdateListener(this._onUpdate);
      if (this.props.global) {
        element = this._getElementToBind();
        return element.removeEventListener('shortcuts:global', this._customGlobalHandler);
      }
    },
    _handleShortcuts: function(event, keyName) {
      var shortcutName;
      shortcutName = this.context.shortcuts.findShortcutName(keyName, this.props.name);
      return this.props.handler(shortcutName, event);
    },
    render: function() {
      return shortcuts({
        tabIndex: this.props.tabIndex || -1,
        className: this.props.className
      }, this.props.children);
    }
  });

}).call(this);
